local Tunnel = module("vrp", "lib/Tunnel")
local Proxy = module("vrp", "lib/Proxy")

vRP = Proxy.getInterface("vRP")
vRPclient = Tunnel.getInterface("vRP", "brx_ffa")
vRPCFFA = Tunnel.getInterface("brx_ffa", "brx_ffa")

vRPSFFA = {}
Tunnel.bindInterface("vRPSFFA", vRPSFFA)

local inFFA = {}
GlobalState['playersPlaying'] = 0;
GlobalState['currentMap'] = 'Loading...';
GlobalState['statusArena'] = '~r~Inchisa';
GlobalState['FFATimer'] = 0;
timerStarted = false;
local tempTbl = {};
local timeoutSpam = {};

function generateRandomMap()
    GlobalState['currentMap'] = ffaConfig.numeHarti[math.random(1,#ffaConfig.numeHarti)]
end
CreateThread(function()
    Wait(5000)
    GlobalState['statusArena'] = '~g~Deschisa';
    generateRandomMap()
end)

RegisterNetEvent("FFA:playerDied", function (killer,distCoords)
    local killer = tonumber(killer);
    local player = source;
    if killer == player then killer = -1 end;
    local user_id = vRP.getUserId{player};
    if not user_id then return end;
    vRPCFFA.isInFFAandComa(player, {}, function (InComa)
        if not InComa then return end;
        Player(player).state.FFADeaths = (Player(player).state.FFADeaths or 0) + 1; 
        if killer > 0 then
          local killerId = vRP.getUserId{killer};
          if not killerId then return end;
          Player(killer).state.FFAKills = (Player(killer).state.FFAKills or 0) + 1;
          TriggerClientEvent('newKill', -1,vRP.getPlayerName({player}), vRP.getPlayerName({killer}), false, ( GetSelectedPedWeapon(GetPlayerPed(killer)) or -1), math.round(distCoords))
          vRPclient.varyHealth(killer, {ffaConfig.healthOnKill})
          if math.random(100) <= ffaConfig.armourChance then
            vRPCFFA.varyArmour(killer, {ffaConfig.armourOnKill})
          end
        end
        local coords = ffaConfig.zone[GlobalState.currentMap][math.random(1,#ffaConfig.zone[GlobalState.currentMap])]
        TriggerClientEvent("FFA:respawnPlayer", player, coords[1], coords[2], coords[3], true)
    end)
end)

RegisterCommand('changestatus',function(source,args,rawCommand)
    if not (source == 0) then return end;
    if not args[1] or parseInt(args[1]) > 2 then return print("^1Error: ^0/changestatus [1 - deschis / 0 - inchis]") end;

    if parseInt(args[1]) == 1 then
        GlobalState['statusArena'] = '~g~Deschisa';
        TriggerClientEvent(ffaConfig.triggerChat, -1,ffaConfig.openArena);
    else
        GlobalState['statusArena'] = '~r~Inchisa';
        for k in pairs(inFFA) do
            TriggerClientEvent('FFA:respawnPlayer',k,ffaConfig.position[1],ffaConfig.position[2],ffaConfig.position[3], true)
            TriggerClientEvent(ffaConfig.triggerChat,k,ffaConfig.arenaClosedMessage)
            SetPlayerRoutingBucket(k, 0);
            TriggerEvent(ffaConfig.triggerVirtualWorld, k, 0);
            TriggerClientEvent('FFA:changeState',k,false);
            RemoveAllPedWeapons(k,true);
            inFFA[k] = nil;
        end
        GlobalState['playersPlaying'] = 0;
    end
    print('^2Success: ^0Status-ul arenei a fost modificat cu succes!');
end)

function startTimer(time)
    time = tonumber(time)
    if time > 0 then
        GlobalState['FFATimer'] = time;
        timerStarted = true;
        local maxKills = -1;
        while timerStarted do
            GlobalState['FFATimer'] = (GlobalState['FFATimer'] or 0) - 1;
            if (GlobalState['FFATimer'] or 0) < 1 then
                GlobalState['FFATimer'] = 0;
                for v,k in pairs(inFFA) do
                    if Player(k).state.FFAKills ~= nil then
                        if (Player(k).state.FFAKills or 0) > maxKills then
                            maxKills = k
                        end
                        TriggerClientEvent('FFA:respawnPlayer',k,ffaConfig.position[1],ffaConfig.position[2],ffaConfig.position[3], true)
                        SetPlayerRoutingBucket(k, 0);
                        TriggerEvent(ffaConfig.triggerVirtualWorld, k, 0);
                        TriggerClientEvent('FFA:changeState',k,false);
                        RemoveAllPedWeapons(k,true);
                        GlobalState['playersPlaying'] = 0;
                        inFFA[v] = nil;
                        timeoutSpam[v] = nil;
                        generateRandomMap();
                        SetTimeout(500,function()
                            vRPclient.notify(k, {"Ai primit armele tale inapoi."})
                            vRPclient.giveWeapons(k,{tempTbl[v],true})
                            tempTbl[v] = nil;
                        end)
                    end
                end
                timerStarted = false;
            end
            Wait(1000)
        end
    end
end

RegisterCommand('ffa',function(source)
    if (source == 0) then return print('^1Error: ^0Aceasta comanda nu poate fi executata de catre consola.') end
    local coords = GetEntityCoords(GetPlayerPed(source));
    if not coords then return end;
    if #(vector3(coords) - ffaConfig.position) > 5 then return vRPclient.notify(source,{ffaConfig.langNotArena}) end;
    local user_id = vRP.getUserId{source};
    if not user_id then return end;
    if GlobalState['statusArena'] == '~r~Inchisa' then return vRPclient.notify(source,{ffaConfig.ArenaClosedNotify}) end;
    if not inFFA[user_id] then
        if not timeoutSpam[user_id] then
            GlobalState['playersPlaying'] = GlobalState['playersPlaying'] + 1;        
            inFFA[user_id] = source;
            vRPclient.setHealth(source,{200});
            TriggerClientEvent('sxint:blockInventory',source,true);
            vRPclient.getWeapons(source,{},function(weapons)
                tempTbl[user_id] = weapons;
                vRPclient.giveWeapons(source,{{},true})
            end)

            Player(source).state.FFAKills = 0;
            Player(source).state.FFADeaths = 0;
            SetTimeout(100,function()
                local coordsbasina = ffaConfig.zone[GlobalState.currentMap][math.random(1,#ffaConfig.zone[GlobalState.currentMap])]
                TriggerClientEvent("FFA:respawnPlayer", source, coordsbasina[1], coordsbasina[2], coordsbasina[3], false)
                TriggerClientEvent('FFA:changeState',source,true);
                SetPlayerRoutingBucket(source, ffaConfig.virtualWorld);
                TriggerEvent(ffaConfig.triggerVirtualWorld, source, ffaConfig.virtualWorld);
                vRPclient.giveWeapons(source,{ffaConfig.weapons,true});
                if GlobalState['playersPlaying'] >= ffaConfig.playersNeedToStart and (GlobalState['FFATimer'] or 0) < 1 then
                    startTimer(ffaConfig.ffaTimer);
                end

                timeoutSpam[user_id] = true;
                SetTimeout(ffaConfig.spamTimeout * 1000,function()
                    timeoutSpam[user_id] = nil;
                end)
            end)
        else
            vRPclient.notify(source,{"Cooldown! Asteapta "..ffaConfig.spamTimeout.." secunde!"})
        end
    else
        vRPclient.notify(source,{"Esti deja in FFA, foloseste comanda /leaveffa pentru a iesi din arena."});
    end
end)

AddEventHandler('vRP:playerLeave',function(user_id)
    if not inFFA[user_id] then return end;
    GlobalState['playersPlaying'] = GlobalState['playersPlaying']-1;
    inFFA[user_id] = nil;
    tempTbl[user_id] = nil;
end)

RegisterCommand('leaveffa',function(source)
    if (source == 0) then return print("^1Error: ^0Aceasta comanda nu poate fi executata de catre consola.") end;
    local user_id = vRP.getUserId{source};
    if not user_id then return end;
   
    if inFFA[user_id] then
        GlobalState['playersPlaying'] = GlobalState['playersPlaying']-1;
        inFFA[user_id] = nil;
        Player(source).state.FFAKills = 0;
        Player(source).state.FFADeaths = 0;
        RemoveAllPedWeapons(source,true);
        TriggerClientEvent('sxint:blockInventory',source,false);
        TriggerClientEvent("FFA:respawnPlayer",source,ffaConfig.position[1], ffaConfig.position[2], ffaConfig.position[3],true);
        TriggerClientEvent('FFA:changeState',source,false);
        SetPlayerRoutingBucket(source,0);
        SetTimeout(500,function()
            vRPclient.notify(source,{"Ai primit armele inapoi."})
            vRPclient.giveWeapons(source,{tempTbl[user_id],true})
            tempTbl[user_id] = nil;
        end)
        if timerStarted and (GlobalState['playersPlaying'] or 0) < 2 then
            timerStarted = false;
            startTimer(1);
        end
    else
        vRPclient.notify(source,{"Nu poti folosi aceasta comanda deoarece nu te afli in FFA."});
    end
end)